/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC32P8141
;  *   	@Create Date         : 2020.05.26
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	        ƵУ׼
                ϵʼT0ʱãFT0=LIRC Ƶ
                T0ʱ1SȡCNTLHرT0
                ʱ LOADֵT0 1Sж P17ת
                
                Ҫ2S4SٵڶT0ʱ޸ķƵ
                Ҫ0.5S0.25SٵڶT0ʱLOADֵ λװֵΪ0
   	   	   	   	޸ƵӦʱʱҲҪ޸
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm 
   	movai   0x7F 
   	movra   FSR0
   	clrr    INDF0
   	DJZR    FSR0 
   	goto    $ -2 
   	clrr    INDF0
__endasm;
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    IOP0 = 0x00; //ioλ
    OEP0 = 0xff; //ioڷ 1:out  0:in
    PUP0 = 0x00; //io   1:enable  0:disable
    PDP0 = 0x00; //io   1:enable  0:disable

    IOP1 = 0x00; //ioλ
    OEP1 = 0xff; //ioڷ 1:out  0:in
    PUP1 = 0x00; //io   1:enable  0:disable
    PDP1 = 0x00; //io   1:enable  0:disable

    P0ADCR = 0x00; //˿ģ   1:ģ  0:
    P1ADCR = 0x00; //˿ģ   1:ģ  0:
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    GIE = 1;
}
/************************************************
;  *    @Function Name       : Delay_1S
;  *    @Description         : ʱ1s
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void Delay_1S(void)
{
    uint8_t cnth;
    uint8_t cntm;
    uint8_t cntl;     
    
    while (1)
    {
        cntl++;
        if (cntl == 0)
        {
            cntm++;
            if (cntm == 0)
            {
                cnth++;
            }
        }
        if ((cnth >= DELAY_NUM_H) && (cntm >= DELAY_NUM_M) && (cntl >= DELAY_NUM_L))
        {
            break;
        }
    }
    // P17D=1;
    // __asm
    // T1END:
    //     	JZR	   	_cntl
    //     	goto   	$+4
    //     	JZR	   	_cntm
    //     	goto   	$+2
    //     	INCR   	   _cnth
    
    //     	MOVAI  	0xf0
    //     	RSUBAR 	_cntl
    //     	MOVAI  	0x48
    //     	RSBCAR 	_cntm
    //     	MOVAI  	0x01
    //     	RSBCAR 	_cnth
    //     	JBSET  	PFLAG,0
    //     	goto   	T1END
    // __endasm;
    // P17D=0;
}
/************************************************
;  *    @Function Name       : LIRC_ADJ
;  *    @Description         : ƵУ׼
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void LIRC_ADJ(void)
{
    //T0
    T0IF = 0;
    T0EN = 0;

    T0CR = 0x10; //FLOSC Ƶ
    T0LOADH = 0xff;
    T0LOADL = 0xff;
    T0IE=0; //رնʱ0ж
    T0EN = 1;      //ʹܶʱ0 

    P17D = 1;       //ʱʱ
   	Delay_1S();
    P17D = 0;       //ʱʱ

    u8_templ = 0xff - T0CNTL;
    u8_temph = 0xff - T0CNTH;
    u8_templ = 0xff - T0CNTL;
    u8_temph = 0xff - T0CNTH;   //Ϊȶȡ
    T0EN = 0;       //رնʱ
    T0IF = 0;  
   	//Ҫʱ2S  ѡ2Ƶ
    //Ҫʱ0.5S  LOADֵƣλװֵΪ0
    T0CR = 0x10; //FLOSC Ƶ 1S
   	T0LOADH = u8_temph;
    T0LOADL = u8_templ;
    //T0LOADH = u8_temph>>1;
    //T0LOADL = u8_templ>>1;
    T0EN = 1;   //ʹܶʱ0    
    T0IE = 1;   //ʹܶʱж
}
void main(void)
{
    Sys_Init();
    LFEN = 1; //Ƶʱӹ
    while (!STBL); //ȴƵȶ
    LIRC_ADJ();     //ƵУ׼
    while (1)
    {
    }
}

void int_isr(void) __interrupt
{
__asm 
    movra   _abuf
    swapar  _PFLAG
    movra   _statusbuf
__endasm;
    if ((T0IE) && (T0IF))       //T0ж
    {
        T0IF = 0;
        //P17ת
   	__asm       
        MOVAI 10000000B         
        XORRA IOP1
   	__endasm;
    }
__asm 
    swapar  _statusbuf
    movra   _PFLAG
    swapr   _abuf
    swapar  _abuf
__endasm;
}
